<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (108)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="dispatching-custom-events">Dispatching custom events</h1>
    <p>
      We can not only assign handlers, but also generate events from JavaScript.
    </p>
    <p>
      Custom events can be used to create “graphical components”. For instance,
      a root element of our own JS-based menu may trigger events telling what
      happens with the menu: <code>open</code> (menu open),
      <code>select</code> (an item is selected) and so on. Another code may
      listen for the events and observe what’s happening with the menu.
    </p>
    <p>
      We can generate not only completely new events, that we invent for our own
      purposes, but also built-in ones, such as <code>click</code>,
      <code>mousedown</code> etc. That may be helpful for automated testing.
    </p>
    <h2 id="event-constructor">Event constructor</h2>
    <p>
      Built-in event classes form a hierarchy, similar to DOM element classes.
      The root is the built-in
      <a href="http://www.w3.org/TR/dom/#event">Event</a> class.
    </p>
    <p>We can create <code>Event</code> objects like this:</p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">let</span> event <span class="op">=</span> <span class="kw">new</span> <span class="at">Event</span>(type[<span class="op">,</span> options])<span class="op">;</span></a></code></pre>
    </div>
    <p>Arguments:</p>
    <ul>
      <li>
        <em>type</em> – event type, a string like <code>"click"</code> or our
        own like <code>"my-event"</code>.
      </li>
      <li>
        <p><em>options</em> – the object with two optional properties:</p>
        <ul>
          <li>
            <code>bubbles: true/false</code> – if <code>true</code>, then the
            event bubbles.
          </li>
          <li>
            <code>cancelable: true/false</code> – if <code>true</code>, then the
            “default action” may be prevented. Later we’ll see what it means for
            custom events.
          </li>
        </ul>
        <p>
          By default both are false:
          <code>{bubbles: false, cancelable: false}</code>.
        </p>
      </li>
    </ul>
    <h2 id="dispatchevent">dispatchEvent</h2>
    <p>
      After an event object is created, we should “run” it on an element using
      the call <code>elem.dispatchEvent(event)</code>.
    </p>
    <p>
      Then handlers react on it as if it were a regular browser event. If the
      event was created with the <code>bubbles</code> flag, then it bubbles.
    </p>
    <p>
      In the example below the <code>click</code> event is initiated in
      JavaScript. The handler works same way as if the button was clicked:
    </p>
    <p>
      ```html run no-beautify
      <button id="elem" onclick="alert('Click!');">Autoclick</button>
    </p>
    <script>
      let event = new Event("click");
      elem.dispatchEvent(event);
    </script>
    <p>```</p>
    <p>
      ```smart header=“event.isTrusted” There is a way to tell a “real” user
      event from a script-generated one.
    </p>
    <p>
      The property <code>event.isTrusted</code> is <code>true</code> for events
      that come from real user actions and <code>false</code> for
      script-generated events. ```
    </p>
    <h2 id="bubbling-example">Bubbling example</h2>
    <p>
      We can create a bubbling event with the name <code>"hello"</code> and
      catch it on <code>document</code>.
    </p>
    <p>All we need is to set <code>bubbles</code> to <code>true</code>:</p>
    ```html run no-beautify
    <h1 id="elem">Hello from the script!</h1>
    <script>
      // catch on document...
      document.addEventListener("hello", function (event) {
        // (1)
        alert("Hello from " + event.target.tagName); // Hello from H1
      });

      // ...dispatch on elem!
      let event = new Event("hello", { bubbles: true }); // (2)
      elem.dispatchEvent(event);

      // the handler on document will activate and display the message.
    </script>
    <p>```</p>
    <p>Notes:</p>
    <ol type="1">
      <li>
        We should use <code>addEventListener</code> for our custom events,
        because <code>on&lt;event&gt;</code> only exists for built-in events,
        <code>document.onhello</code> doesn’t work.
      </li>
      <li>
        Must set <code>bubbles:true</code>, otherwise the event won’t bubble up.
      </li>
    </ol>
    <p>
      The bubbling mechanics is the same for built-in (<code>click</code>) and
      custom (<code>hello</code>) events. There are also capturing and bubbling
      stages.
    </p>
    <h2 id="mouseevent-keyboardevent-and-others">
      MouseEvent, KeyboardEvent and others
    </h2>
    <p>
      Here’s a short list of classes for UI Events from the
      <a href="https://www.w3.org/TR/uievents">UI Event specification</a>:
    </p>
    <ul>
      <li><code>UIEvent</code></li>
      <li><code>FocusEvent</code></li>
      <li><code>MouseEvent</code></li>
      <li><code>WheelEvent</code></li>
      <li><code>KeyboardEvent</code></li>
      <li>…</li>
    </ul>
    <p>
      We should use them instead of <code>new Event</code> if we want to create
      such events. For instance, <code>new MouseEvent("click")</code>.
    </p>
    <p>
      The right constructor allows to specify standard properties for that type
      of event.
    </p>
    <p>Like <code>clientX/clientY</code> for a mouse event:</p>
    <p>
      ```js run let event = new MouseEvent(“click”, { bubbles: true, cancelable:
      true, clientX: 100, clientY: 100 });
    </p>
    <p><em>!</em> alert(event.clientX); // 100 <em>/!</em> ```</p>
    <p>
      Please note: the generic <code>Event</code> constructor does not allow
      that.
    </p>
    <p>Let’s try:</p>
    <p>
      ```js run let event = new Event(“click”, { bubbles: true, // only bubbles
      and cancelable cancelable: true, // work in the Event constructor clientX:
      100, clientY: 100 });
    </p>
    <p>
      <em>!</em> alert(event.clientX); // undefined, the unknown property is
      ignored! <em>/!</em> ```
    </p>
    <p>
      Technically, we can work around that by assigning directly
      <code>event.clientX=100</code> after creation. So that’s a matter of
      convenience and following the rules. Browser-generated events always have
      the right type.
    </p>
    <p>
      The full list of properties for different UI events is in the
      specification, for instance,
      <a href="https://www.w3.org/TR/uievents/#mouseevent">MouseEvent</a>.
    </p>
    <h2 id="custom-events">Custom events</h2>
    <p>
      For our own, completely new events types like <code>"hello"</code> we
      should use <code>new CustomEvent</code>. Technically
      <a href="https://dom.spec.whatwg.org/#customevent">CustomEvent</a> is the
      same as <code>Event</code>, with one exception.
    </p>
    <p>
      In the second argument (object) we can add an additional property
      <code>detail</code> for any custom information that we want to pass with
      the event.
    </p>
    <p>For instance:</p>
    ```html run refresh
    <h1 id="elem">Hello for John!</h1>
    <script>
        // additional details come with the event to the handler
        elem.addEventListener("hello", function(event) {
          alert(*!*event.detail.name*/!*);
        });

        elem.dispatchEvent(new CustomEvent("hello", {
      *!*
          detail: { name: "John" }
      */!*
        }));
    </script>
    <p>```</p>
    <p>
      The <code>detail</code> property can have any data. Technically we could
      live without, because we can assign any properties into a regular
      <code>new Event</code> object after its creation. But
      <code>CustomEvent</code> provides the special <code>detail</code> field
      for it to evade conflicts with other event properties.
    </p>
    <p>
      Besides, the event class describes “what kind of event” it is, and if the
      event is custom, then we should use <code>CustomEvent</code> just to be
      clear about what it is.
    </p>
    <h2 id="event.preventdefault">event.preventDefault()</h2>
    <p>
      Many browser events have a “default action”, such as navigating to a link,
      starting a selection, and so on.
    </p>
    <p>
      For new, custom events, there are definitely no default browser actions,
      but a code that dispatches such event may have its own plans what to do
      after triggering the event.
    </p>
    <p>
      By calling <code>event.preventDefault()</code>, an event handler may send
      a signal that those actions should be canceled.
    </p>
    <p>
      In that case the call to <code>elem.dispatchEvent(event)</code> returns
      <code>false</code>. And the code that dispatched it knows that it
      shouldn’t continue.
    </p>
    <p>
      Let’s see a practical example - a hiding rabbit (could be a closing menu
      or something else).
    </p>
    <p>
      Below you can see a <code>#rabbit</code> and <code>hide()</code> function
      that dispatches <code>"hide"</code> event on it, to let all interested
      parties know that the rabbit is going to hide.
    </p>
    <p>
      Any handler can listen for that event with
      <code>rabbit.addEventListener('hide',...)</code> and, if needed, cancel
      the action using <code>event.preventDefault()</code>. Then the rabbit
      won’t disappear:
    </p>
    ```html run refresh autorun
    <pre id="rabbit">
  |\   /|
   \|_|/
   /. .\
  =\_Y_/=
   {>o<}
</pre
    >
    <button onclick="hide()">Hide()</button>
    <script>
      function hide() {
        let event = new CustomEvent("hide", {
          cancelable: true, // without that flag preventDefault doesn't work
        });
        if (!rabbit.dispatchEvent(event)) {
          alert("The action was prevented by a handler");
        } else {
          rabbit.hidden = true;
        }
      }

      rabbit.addEventListener("hide", function (event) {
        if (confirm("Call preventDefault?")) {
          event.preventDefault();
        }
      });
    </script>
    <p>```</p>
    <p>
      Please note: the event must have the flag <code>cancelable: true</code>,
      otherwise the call <code>event.preventDefault()</code> is ignored.
    </p>
    <h2 id="events-in-events-are-synchronous">
      Events-in-events are synchronous
    </h2>
    <p>
      Usually events are processed in a queue. That is: if the browser is
      processing <code>onclick</code> and a new event occurs, e.g. mouse moved,
      then it’s handling is queued up, corresponding
      <code>mousemove</code> handlers will be called after
      <code>onclick</code> processing is finished.
    </p>
    <p>
      The notable exception is when one event is initiated from within another
      one, e.g. using <code>dispatchEvent</code>. Such events are processed
      immediately: the new event handlers are called, and then the current event
      handling is resumed.
    </p>
    <p>
      For instance, in the code below the <code>menu-open</code> event is
      triggered during the <code>onclick</code>.
    </p>
    <p>
      It’s processed immediately, without waiting for
      <code>onclick</code> handler to end:
    </p>
    <p>```html run autorun <button id="menu">Menu (click me)</button></p>
    <script>
      menu.onclick = function () {
        alert(1);

        menu.dispatchEvent(
          new CustomEvent("menu-open", {
            bubbles: true,
          })
        );

        alert(2);
      };

      // triggers between 1 and 2
      document.addEventListener("menu-open", () => alert("nested"));
    </script>
    <p>```</p>
    <p>The output order is: 1 -&gt; nested -&gt; 2.</p>
    <p>
      Please note that the nested event <code>menu-open</code> is caught on the
      <code>document</code>. The propagation and handling of the nested event is
      finished before the processing gets back to the outer code
      (<code>onclick</code>).
    </p>
    <p>
      That’s not only about <code>dispatchEvent</code>, there are other cases.
      If an event handler calls methods that trigger other events – they are
      processed synchronously too, in a nested fashion.
    </p>
    <p>
      Let’s say we don’t like it. We’d want <code>onclick</code> to be fully
      processed first, independently from <code>menu-open</code> or any other
      nested events.
    </p>
    <p>
      Then we can either put the <code>dispatchEvent</code> (or another
      event-triggering call) at the end of <code>onclick</code> or, maybe
      better, wrap it in the zero-delay <code>setTimeout</code>:
    </p>
    <p>```html run <button id="menu">Menu (click me)</button></p>
    <script>
      menu.onclick = function () {
        alert(1);

        setTimeout(() =>
          menu.dispatchEvent(
            new CustomEvent("menu-open", {
              bubbles: true,
            })
          )
        );

        alert(2);
      };

      document.addEventListener("menu-open", () => alert("nested"));
    </script>
    <p>```</p>
    <p>
      Now <code>dispatchEvent</code> runs asynchronously after the current code
      execution is finished, including <code>menu.onclick</code>, so event
      handlers are totally separate.
    </p>
    <p>The output order becomes: 1 -&gt; 2 -&gt; nested.</p>
    <h2 id="summary">Summary</h2>
    <p>
      To generate an event from code, we first need to create an event object.
    </p>
    <p>
      The generic <code>Event(name, options)</code> constructor accepts an
      arbitrary event name and the <code>options</code> object with two
      properties:
    </p>
    <ul>
      <li><code>bubbles: true</code> if the event should bubble.</li>
      <li>
        <code>cancelable: true</code> if the
        <code>event.preventDefault()</code> should work.
      </li>
    </ul>
    <p>
      Other constructors of native events like <code>MouseEvent</code>,
      <code>KeyboardEvent</code> and so on accept properties specific to that
      event type. For instance, <code>clientX</code> for mouse events.
    </p>
    <p>
      For custom events we should use <code>CustomEvent</code> constructor. It
      has an additional option named <code>detail</code>, we should assign the
      event-specific data to it. Then all handlers can access it as
      <code>event.detail</code>.
    </p>
    <p>
      Despite the technical possibility of generating browser events like
      <code>click</code> or <code>keydown</code>, we should use them with great
      care.
    </p>
    <p>
      We shouldn’t generate browser events as it’s a hacky way to run handlers.
      That’s bad architecture most of the time.
    </p>
    <p>Native events might be generated:</p>
    <ul>
      <li>
        As a dirty hack to make 3rd-party libraries work the needed way, if they
        don’t provide other means of interaction.
      </li>
      <li>
        For automated testing, to “click the button” in the script and see if
        the interface reacts correctly.
      </li>
    </ul>
    <p>
      Custom events with our own names are often generated for architectural
      purposes, to signal what happens inside our menus, sliders, carousels etc.
    </p>
  </body>
</html>
